; Faust, ripping off Linux since 1695! (actually an alternative to GNU/Linux to set people free from having to use it to have a free software OS), this is the first stage bootloader
; Copyright (C) 2013  Thijs van der Woude

; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

bits 16 		; This is 16 bit
org 0x7c00		; Load this at 0x7c00

start: jmp boot		; Jump to the bootloader

; Data

msg db "Faust stage 1 bootloader executing", 0x0D, 0x0A, 0x00	; Loading message

bpbOEM db "Faust   "		; OS name
bpbBytesPerSector: dw 512	; Bytes per sector, duh
bpbNumberOfFATs: db 2
bpbRootEntries: dw 224
bpbTotalSectors: dw 2880
bpbMedia: db 0xF0
bpbSectorsPerFAT: dw 9
bpbSectorsPerTrack: dw 18
bpbHeadsPerCylinder: dw 2
bpbHiddenSectors: dd 0
bpbTotalSectorsBig: dd 0
bsDriveNumber: db 0
bsUnused: db 0
bsExtBootSignature: db 0x29
bsSerialNumber:	dd 0xa0a1a2a3
bsVolumeLabel: db"FST FLOPPY "
bsFileSystem: db "FAT12   "

; Code

boot: 

		mov si, msg
		mov ah, 0eh
	.msg:			; Print the loading string
		lodsb			; Move next byte from si into al
		or al, al		; al = 0? (is the end of the string reached?)
		jz .msgx		; Yep, continue booting
		int 0x10		; No, call the BIOS
		jmp .msg		; Repeat
	.msgx:			; After message is printed
		cli
		hlt
		
times 510-($-$$) db 0	; (First stage) bootloaders have to be 512 bytes
dw 0xAA55				; Our boot signature to tell the BIOS to boot this